VERSION 5.00
Object = "{CAB249C7-BAC9-4C51-9526-12F29E40C4CE}#2.6#0"; "ExTvw.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   7029
   ClientLeft      =   4433
   ClientTop       =   2431
   ClientWidth     =   5742
   LinkTopic       =   "Form1"
   ScaleHeight     =   7029
   ScaleWidth      =   5742
   Begin VB.CommandButton Command 
      Caption         =   "Finish"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.07
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   451
      Index           =   2
      Left            =   1584
      TabIndex        =   3
      Top             =   6468
      Width           =   2563
   End
   Begin VB.CommandButton Command 
      Caption         =   "Jump to Previous Filter Result"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.07
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   451
      Index           =   1
      Left            =   2948
      TabIndex        =   2
      Top             =   5940
      Width           =   2563
   End
   Begin VB.CommandButton Command 
      Caption         =   "Jump to Next Filter Result"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.07
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   451
      Index           =   0
      Left            =   132
      TabIndex        =   1
      Top             =   5940
      Width           =   2563
   End
   Begin ExTvw.ExplorerTreeView ExplorerTreeView1 
      Height          =   5720
      Left            =   88
      TabIndex        =   0
      Top             =   44
      Width           =   5555
      _ExtentX        =   9794
      _ExtentY        =   10099
      Appearance      =   2
      DrivesOnly      =   -1  'True
      FileAttributes  =   63
      FireBeforeInsertItem=   15
      FolderAttributes=   63
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Verdana"
         Size            =   8.064
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      HotTracking     =   -1  'True
      IncludedItems   =   15
      Indent          =   19
      ItemHeight      =   19
      LimitEditInput  =   0   'False
      RootPath        =   "Arbeitsplatz"
      SingleExpand    =   2
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
 
'##############################################################
 
' Demo Project for TimoSoft Concerning "Find Filter Results"
' 04.09.2009
'##############################################################

Private ETV As ExplorerTreeView

Option Explicit
 
Private Sub Form_Load()
    
   ' Reference to ExplorerTreeView
   Set ETV = ExplorerTreeView1
    
   ' Set and Apply Filters
   ' For Reasons of Simplicity only
   ' One Single File Filter
   With ETV
      .FileFilters = "*.txt"
      .UseFileFilters = True
      .UseFolderFilters = False
   End With
    
End Sub
 
Private Sub Command_Click(Index As Integer)
    
   Select Case Index
   
      Case 0
         ' Next Filter Result:
         ' Search Downwards for the Next File, Matching Filter Settings,
         ' and Make it the Selected Tree Item
         Do
            DoEvents
         Loop Until Next_Filter_Result(ETV.SelectedItem)
         ETV.SetFocus
          
      Case 1
         ' Previous Filter Result:
         ' Search Upwards for the Next File, Matching Filter Settings,
         ' and Make it the Selected Tree Item
          
         ' Not Implemented Yet. Idea:
         ' Make a Correct "Next_Filter_Result"-Function/Sub
         ' Working into the Other Direction
         
      Case 2
         ' Finish
         Unload Me
         
   End Select
    
End Sub
 
Public Function Next_Filter_Result(ByVal hSelection As Long) As Boolean
    
   Dim hNext As Long
    
   ' Find Next Item Matching Folder/File Filter Settings
   With ETV
      hNext = .ItemGetFirstSubItem(hSelection)
      If hNext = -1 Then
         hNext = .ItemGetNextItem(hSelection)
      End If
      Do While hNext <> -1
         If .ItemIsPartOfFileSystem(hNext) Then
            .SelectedItem = hNext
            .ItemEnsureVisible hNext
            Next_Filter_Result = True
            Exit Function
         End If
         If Next_Filter_Result(hNext) Then
            Next_Filter_Result = True
            Exit Function
         End If
         hNext = .ItemGetNextItem(hNext)
      Loop
   End With
    
End Function
